// GOOD CODE AND WORK

#include"DHT11_Lib_12F1840.h"
#include"My_UART1_Lib.h"
#define CLS 12
#define CR 0x0D
#define LF 10
#define TAB 9
#define Blancs "  "  // 2  spaces
#define Separator 0x20   // 1 space
#define MAX_LEN1 128
#define MAX_LEN2 24
#define MAX_LEN3 80
unsigned char Buffer[MAX_LEN1];
unsigned short read_vec[2];

void fill_buffer(unsigned short t , unsigned short th)
{
 unsigned short i,vect_t[4],vect_th[4];
 ByteToStr(t,vect_t); ByteToStr(th,vect_th);
 for(i=0;i<3;i++) {UART1_Write('.');delay_ms(200);} // erase Buffer vector.
 for(i=0 ; i<MAX_LEN1 ; i++) Buffer[i]=0 ;
 Buffer[0]='.';Buffer[1]='T';Buffer[2]='e';Buffer[3]='m';
 Buffer[4]='p';Buffer[5]=':';Buffer[6]=vect_t[1];Buffer[7]=vect_t[2];
 Buffer[8]='C';Buffer[9]=' ';Buffer[10]=' ';Buffer[11]='H';Buffer[12]='u';
 Buffer[13]='m';Buffer[14]='i';Buffer[15]='d';Buffer[16]=':';
 Buffer[17]=vect_th[1];Buffer[18]=vect_th[2];Buffer[19]='%';
}
void main() {
  unsigned short sum;
  unsigned char *text;
  unsigned char mytext[4];
  // SET INTERNAL OSCILLATOR TO 32MHZ (INTERNAL CLOCK AY 8 + PLLEN=4X)
  OSCCON.SCS0 = 0;OSCCON.SCS1 =1;
  OSCCON.IRCF0=0; OSCCON.IRCF1=1; OSCCON.IRCF3=1; OSCCON.IRCF3=1;
  OSCCON.SPLLEN=1 ;
  PORTA=0;
  ANSELA = 0x00; // All pins digital
  ADCON0 = 0x00; // Disable ADC
  CM1CON0.C1ON = 0; // Disable Comparator
  
  // Initalize USART (9600,8,N,1)
  UART1_Init(9600);
  Delay_ms(500);
  UART1_Write(CLS);
  My_CRLF();
  
  My_UART1_Write_CText("Program acuire Humidity \r\n");
  My_UART1_Write_CText("and Temperature values \r\n");
  My_UART1_Write_CText("fron DHT11 sensor\r\n");
  My_CRLF();

 //TRISA = 0;        //Configure PORTB as output
 //PORTA = 0;        //Initial value of PORTB
 while(1){
          StartSignal();
          if(CheckResponse()){
               ReadData();

               if(sum = read_vec[0] + read_vec[1]){
                    fill_buffer(read_vec[1],read_vec[0]);
                                               //Parameters: read_vec[0]=Humid.
                                               // read_vec[1] = Temperature.
                    My_UART1_Write_CText(Buffer); My_CRLF();
                }
               else error();

             }
          else error();
          delay_ms(300);
          }  // END WHILE

} // End Main




// ================================================================
//          Vss RA0 RA1 RA2           RA0: TX
//            |  |  |  |              RA1: RX ; SCL
//           +----------+             RA2: SDA
//           o 12F1840  |             RA3:
//           +----------+             RA4:
//            |  |  |  |              RA5:
//          Vdd RA5 RA4 RA3
//
//  INTERNAL CLOCK AT 4MHZ + PLL AT 4X = 32 MHZ REAL INTERNAL CLOCK
// ================================================================
// ByteToStr(rh,mytext);Ltrim(mytext));