
_StartSignal:

;DHT11_Lib_12F1840.c,18 :: 		void StartSignal(){
;DHT11_Lib_12F1840.c,19 :: 		DataPinDir = 0;    //Configure RB6 as output
	BCF        TRISA4_bit+0, BitPos(TRISA4_bit+0)
;DHT11_Lib_12F1840.c,20 :: 		DataPin = 0;    //RB6 sends 0 to the sensor
	BCF        RA4_bit+0, BitPos(RA4_bit+0)
;DHT11_Lib_12F1840.c,21 :: 		delay_ms(18);
	MOVLW      47
	MOVWF      R12
	MOVLW      191
	MOVWF      R13
L_StartSignal0:
	DECFSZ     R13, 1
	GOTO       L_StartSignal0
	DECFSZ     R12, 1
	GOTO       L_StartSignal0
	NOP
	NOP
;DHT11_Lib_12F1840.c,22 :: 		DataPin = 1;    //RB6 sends 1 to the sensor
	BSF        RA4_bit+0, BitPos(RA4_bit+0)
;DHT11_Lib_12F1840.c,23 :: 		delay_us(30);
	MOVLW      19
	MOVWF      R13
L_StartSignal1:
	DECFSZ     R13, 1
	GOTO       L_StartSignal1
	NOP
	NOP
;DHT11_Lib_12F1840.c,24 :: 		DataPin = 1;    //Configure RB6 as input
	BSF        RA4_bit+0, BitPos(RA4_bit+0)
;DHT11_Lib_12F1840.c,25 :: 		}
L_end_StartSignal:
	RETURN
; end of _StartSignal

_CheckResponse:

;DHT11_Lib_12F1840.c,27 :: 		unsigned short CheckResponse(){
;DHT11_Lib_12F1840.c,29 :: 		check = 0;
	CLRF       R1+0
;DHT11_Lib_12F1840.c,30 :: 		delay_us(40);
	MOVLW      26
	MOVWF      R13
L_CheckResponse2:
	DECFSZ     R13, 1
	GOTO       L_CheckResponse2
	NOP
;DHT11_Lib_12F1840.c,31 :: 		if (DataPin == 0){
	BTFSC      RA4_bit+0, BitPos(RA4_bit+0)
	GOTO       L_CheckResponse3
;DHT11_Lib_12F1840.c,32 :: 		delay_us(80);
	MOVLW      53
	MOVWF      R13
L_CheckResponse4:
	DECFSZ     R13, 1
	GOTO       L_CheckResponse4
;DHT11_Lib_12F1840.c,33 :: 		if (DataPin == 1)   check = 1;   delay_us(40);
	BTFSS      RA4_bit+0, BitPos(RA4_bit+0)
	GOTO       L_CheckResponse5
	MOVLW      1
	MOVWF      R1+0
L_CheckResponse5:
	MOVLW      26
	MOVWF      R13
L_CheckResponse6:
	DECFSZ     R13, 1
	GOTO       L_CheckResponse6
	NOP
;DHT11_Lib_12F1840.c,34 :: 		}
L_CheckResponse3:
;DHT11_Lib_12F1840.c,35 :: 		return check;
	MOVF       R1+0, 0
	MOVWF      R0
;DHT11_Lib_12F1840.c,36 :: 		}
L_end_CheckResponse:
	RETURN
; end of _CheckResponse

_ReadData:

;DHT11_Lib_12F1840.c,38 :: 		unsigned short ReadData(){
;DHT11_Lib_12F1840.c,40 :: 		for(c=1; c<6; c++)
	MOVLW      1
	MOVWF      R3+0
L_ReadData7:
	MOVLW      6
	SUBWF      R3+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_ReadData8
;DHT11_Lib_12F1840.c,42 :: 		for(b=0; b<8; b++){
	CLRF       R4+0
L_ReadData10:
	MOVLW      8
	SUBWF      R4+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_ReadData11
;DHT11_Lib_12F1840.c,43 :: 		while(!DataPin);                   //Wait until PORTB.F6 goes HIGH
L_ReadData13:
	BTFSC      RA4_bit+0, BitPos(RA4_bit+0)
	GOTO       L_ReadData14
	GOTO       L_ReadData13
L_ReadData14:
;DHT11_Lib_12F1840.c,44 :: 		delay_us(30);
	MOVLW      19
	MOVWF      R13
L_ReadData15:
	DECFSZ     R13, 1
	GOTO       L_ReadData15
	NOP
	NOP
;DHT11_Lib_12F1840.c,45 :: 		if(DataPin == 0)  i&=~(1<<(7-b));   //Clear bit (7-b)
	BTFSC      RA4_bit+0, BitPos(RA4_bit+0)
	GOTO       L_ReadData16
	MOVF       R4+0, 0
	SUBLW      7
	MOVWF      R0
	MOVF       R0, 0
	MOVWF      R1
	MOVLW      1
	MOVWF      R0
	MOVF       R1, 0
L__ReadData25:
	BTFSC      STATUS+0, 2
	GOTO       L__ReadData26
	LSLF       R0, 1
	ADDLW      255
	GOTO       L__ReadData25
L__ReadData26:
	COMF       R0, 1
	MOVF       R0, 0
	ANDWF      R2+0, 1
	GOTO       L_ReadData17
L_ReadData16:
;DHT11_Lib_12F1840.c,46 :: 		else{i|= (1 <<( 7 - b));             //Set bit (7-b)
	MOVF       R4+0, 0
	SUBLW      7
	MOVWF      R0
	MOVF       R0, 0
	MOVWF      R1
	MOVLW      1
	MOVWF      R0
	MOVF       R1, 0
L__ReadData27:
	BTFSC      STATUS+0, 2
	GOTO       L__ReadData28
	LSLF       R0, 1
	ADDLW      255
	GOTO       L__ReadData27
L__ReadData28:
	MOVF       R0, 0
	IORWF       R2+0, 1
;DHT11_Lib_12F1840.c,47 :: 		while(DataPin);}                    //Wait until PORTB.F6 goes LOW
L_ReadData18:
	BTFSS      RA4_bit+0, BitPos(RA4_bit+0)
	GOTO       L_ReadData19
	GOTO       L_ReadData18
L_ReadData19:
L_ReadData17:
;DHT11_Lib_12F1840.c,42 :: 		for(b=0; b<8; b++){
	INCF       R4+0, 1
;DHT11_Lib_12F1840.c,48 :: 		}
	GOTO       L_ReadData10
L_ReadData11:
;DHT11_Lib_12F1840.c,49 :: 		if(c==1){read_vec[0] =i; sum=0;} //load 1cell vector whit humidity value
	MOVF       R3+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_ReadData20
	MOVF       R2+0, 0
	MOVWF      _read_vec+0
	CLRF       R5+0
L_ReadData20:
;DHT11_Lib_12F1840.c,50 :: 		if(c==3){read_vec[1]=i;sum=sum+i;}//load 2cell vector whit temper. value
	MOVF       R3+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L_ReadData21
	MOVF       R2+0, 0
	MOVWF      _read_vec+1
	MOVF       R2+0, 0
	ADDWF      R5+0, 1
L_ReadData21:
;DHT11_Lib_12F1840.c,40 :: 		for(c=1; c<6; c++)
	INCF       R3+0, 1
;DHT11_Lib_12F1840.c,51 :: 		}
	GOTO       L_ReadData7
L_ReadData8:
;DHT11_Lib_12F1840.c,52 :: 		return sum;
	MOVF       R5+0, 0
	MOVWF      R0
;DHT11_Lib_12F1840.c,53 :: 		}
L_end_ReadData:
	RETURN
; end of _ReadData

_error:

;DHT11_Lib_12F1840.c,55 :: 		void error(){
;DHT11_Lib_12F1840.c,57 :: 		text="ERROR";
	MOVLW      ?lstr1_DHT11_Lib_12F1840+0
	MOVWF      error_text_L0+0
	MOVLW      hi_addr(?lstr1_DHT11_Lib_12F1840+0)
	MOVWF      error_text_L0+1
;DHT11_Lib_12F1840.c,58 :: 		UART1_Write(text);
	MOVF       error_text_L0+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;DHT11_Lib_12F1840.c,59 :: 		}
L_end_error:
	RETURN
; end of _error
