

#define CLS 12
#define CR 0x0D
#define LF 10
#define TAB 9
#define Blancs "  "  // 2  spaces
#define Separator 0x20   // space

// ============= DHT11 Sensor is connectet to RA4 pin =========
// IF YOU NEED CHANGE DATA PINS CHANGE HERE THE NAME OF THE PIN
sbit DataPin at RA4_bit;
sbit DataPinDir at TRISA4_bit;
// ============================================================

extern unsigned short read_vec[3] ;

 void StartSignal(){
 DataPinDir = 0;    //Configure RB6 as output
 DataPin = 0;    //RB6 sends 0 to the sensor
 delay_ms(18);
 DataPin = 1;    //RB6 sends 1 to the sensor
 delay_us(30);
 DataPin = 1;    //Configure RB6 as input
  }

unsigned short CheckResponse(){
 unsigned short check;
 check = 0;
 delay_us(40);
 if (DataPin == 0){
                    delay_us(80);
                    if (DataPin == 1)   check = 1;   delay_us(40);
                   }
 return check;
 }

 unsigned short ReadData(){
    unsigned short i,c,b,sum;     // sum is th+t value
    for(c=1; c<6; c++)
      {
        for(b=0; b<8; b++){
        while(!DataPin);                   //Wait until PORTB.F6 goes HIGH
        delay_us(30);
        if(DataPin == 0)  i&=~(1<<(7-b));   //Clear bit (7-b)
        else{i|= (1 <<( 7 - b));             //Set bit (7-b)
        while(DataPin);}                    //Wait until PORTB.F6 goes LOW
        }
      if(c==1){read_vec[0] =i; sum=0;} //load 1cell vector whit humidity value
      if(c==3){read_vec[1]=i;sum=sum+i;}//load 2cell vector whit temper. value
      if(c==5){read_vec[2] =i; sum=sum+i;} //load 2cell vector whit
                                                       //Temp float value
      }
 return sum;
 }

 void error(){
      unsigned char *text;
      text="ERROR";
      UART1_Write(text);
  }