// WORK FINE 14/SEP/2017
#include"My_UART1_Lib.h"
#define CLS 12
#define CR 0x0D
#define LF 10
#define TAB 9


void main() {
  // SET INTERNAL OSCILLATOR TO 32MHZ (INTERNAL CLOCK AY 8 + PLLEN=4X)
  OSCCON.SCS0 = 0;OSCCON.SCS1 =1;
  OSCCON.IRCF0=0; OSCCON.IRCF1=1; OSCCON.IRCF3=1; OSCCON.IRCF3=1;
  OSCCON.SPLLEN=1 ;
  //TRISA=0b0000010;
  ANSELA = 0x00; // All pins digital
  ADCON0 = 0x00; // Disable ADC
  CM1CON0.C1ON = 0; // Disable Comparator
  // Initalize USART (9600,8,N,1)
  UART1_Init(9600);
  Delay_ms(500);
  UART1_Write(CLS);
do{
   My_UART1_Write_CText("I'm Here!!! \r\n");
   My_CRLF();
   Delay_ms(500);
} while(1);
} // End Main




// ================================================================
//          Vss RA0 RA1 RA2           RA0: TX
//            |  |  |  |              RA1: RX ; SCL
//           +----------+             RA2: SDA
//           o 12F1840  |             RA3:
//           +----------+             RA4:
//            |  |  |  |              RA5:
//          Vdd RA5 RA4 RA3
// ================================================================